//+------------------------------------------------------------------+
//|                                                          VDI.mq4 |
//|                                                            tener |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "tener"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 1

#property indicator_buffers 5
#property indicator_color1  White
#property indicator_color2  Lime
#property indicator_color3  Red
#property indicator_color4  Green
#property indicator_color5  Green
#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  1
#property indicator_width4  1
#property indicator_width5  1

extern string TimeFrame        = "Current time frame";   
extern bool   ShowNormalVolume = FALSE;
extern int    Search_Distance  = 10;
extern bool   ArrowOnFirstBar  = true;

//---- indicator buffers
double     ExtBuffer1[];
double     ExtBuffer2[];
double     ExtBuffer3[];
double     ExtBuffer4[];
double     ExtBuffer5[];

string indicatorFileName;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexStyle(4,DRAW_ARROW);

   SetIndexBuffer(0,ExtBuffer1);
   SetIndexBuffer(1,ExtBuffer2);
   SetIndexBuffer(2,ExtBuffer3);
   SetIndexBuffer(3,ExtBuffer4);
   SetIndexBuffer(4,ExtBuffer5);
   SetIndexArrow(4,78);
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
   IndicatorShortName(timeFrameToString(timeFrame)+" VDI("+Search_Distance+")");
   SetIndexLabel(0,"Volume");
   IndicatorDigits(0);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{ 
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { ExtBuffer1[0] = limit+1; return(0); }
   
            if (timeFrame!=Period())
            {
               int shift = -1; if (ArrowOnFirstBar) shift=1;
               limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
               for (int i=limit; i>=0; i--)
               {
                  int y = iBarShift(NULL,timeFrame,Time[i]);   
                  int x = iBarShift(NULL,timeFrame,Time[i+shift]);            
                     ExtBuffer1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",ShowNormalVolume,Search_Distance,0,y);
                     ExtBuffer2[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",ShowNormalVolume,Search_Distance,1,y);
                     ExtBuffer3[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",ShowNormalVolume,Search_Distance,2,y);
                     ExtBuffer4[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",ShowNormalVolume,Search_Distance,3,y);
                  if (x!=y)
                  {
                     ExtBuffer5[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",ShowNormalVolume,Search_Distance,4,y);
                  }
               }
               return(0);
            }
    int status;
    for (i=limit; i>=0; i--) 
    {
		status=0;
		if (iHigh(NULL,0,i)>=iHigh(NULL,0,iHighest(NULL,0,MODE_HIGH,Search_Distance,i))) status+=1;
		if ( iLow(NULL,0,i)<=iLow(NULL,0,iLowest(NULL,0,MODE_LOW,Search_Distance,i)))    status+=2;
		switch(status){
			case 0:  if (ShowNormalVolume) ExtBuffer1[i]=Volume[i]; break;
			case 1:  ExtBuffer2[i]=Volume[i]; break;
			case 2:  ExtBuffer3[i]=Volume[i]; break;
			default: ExtBuffer4[i]=Volume[i]; ExtBuffer5[i]=Volume[i]+(Period()*30); break;
		}
	}
//----
   return(0);
  }
//+------------------------------------------------------------------+

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}


